;Chong Carl
;EE 476 Final Project
;S.P.A.R.C.
;Version 2.3b

.include "EQUATES.INC" ;Settings in here.

;Begin code
;INIT the machine, start the ISRs, and exit into idle
;On reset, the 8515 jumps to 0000, which contains a jump vector (see ISR.ASM)

.cseg

.include "Isr.asm"	;Restart vector and Interrupt service routines are here
.include "Init.asm"	;Initialization of timers,ports,and ext hdw.

;At this point, the machine is up and running, the interrupts are enabled, timers 
;are counting, buffers and variables are all initialized, and we're ready to work.

Idle:	
;Check to see if the light bit is on...
;If so then run and stop chirping.
;Else, walk around and chirp.

;Setup the switches to simulate the light detection circuit
;Any switch depression will trigger SPARC to run for cover
	
	ldi	TEMP,$00		;
	out	DDRB,TEMP		;Make port D inputs
	ldi	TEMP,$FF		;
	out	PORTB,TEMP		;Make the pullups on
	in	TEMP,PINB		;Input the switches
	com 	TEMP
	tst	TEMP
	breq	Lights_Off

	rcall	Servo_Lights_On
	rjmp 	Idle

Lights_Off:
	rcall	Servo_Lights_Off
	rjmp	Idle			

;External Routines
.include "Servo.asm"	;RC Servo drivers, 8 channels on port C using timer 1
	
;Lookup tables
.include "Tables.asm"